﻿namespace MvvmStart.Services
{
  using System;
  using System.Text;

  public class FlickrUris
  {
#error "Need an API key for flickR"
    static string apiKey = "Your API Key goes here";
    static string serviceUri = "http://api.flickr.com/services/rest/?method=";
    static string searchMethod = "flickr.photos.search&";
    static string getSizesMethpd = "flickr.photos.getSizes&";
    static string getInfoMethod = "flickr.photos.getInfo&";

    static string MakeUri(string method, params Tuple<string, string>[] entries)
    {
      StringBuilder builder = new StringBuilder();
      builder.AppendFormat("{0}{1}api_key={2}", serviceUri, method, apiKey);

      if (entries != null)
      {
        foreach (var entry in entries)
        {
          builder.AppendFormat("&{0}={1}", entry.Item1, entry.Item2);
        }
      }
      return (builder.ToString());
    }
    public static string MakeSearchUri(string searchTerm)
    {
      string searchUri = MakeUri(searchMethod,
        Tuple.Create("safe_search", "1"),
        Tuple.Create("text", searchTerm),
        Tuple.Create("page", "1"),
        Tuple.Create("per_page", "50"),
        Tuple.Create("content_type", "1")
      );
      return (searchUri);
    }
    public static string MakePhotoInfoUrl(string photoId)
    {
      string searchUri = MakeUri(getInfoMethod,
       Tuple.Create("photo_id", photoId)
      );
      return (searchUri);
    }
    public static string MakeSizesPhotoUri(string photoId)
    {
      string searchUri = MakeUri(getSizesMethpd,
        Tuple.Create("photo_id", photoId)
      );
      return (searchUri);
    }
  }
}
