﻿namespace MvvmStart.ViewModels
{
  using System.Windows.Input;
  using AbstractionsLibrary;
  using Microsoft.Practices.Prism.StoreApps;
  using Microsoft.Practices.Prism.StoreApps.Interfaces;
  using MvvmStart.Services;

  public class SearchPageViewModel : 
    ViewModel  
  {
    public SearchPageViewModel(INavigationService navigationService)
    {
      this._navigationService = navigationService;
    }
    public string SearchTerm
    {
      get
      {
        return (this._searchTerm);
      }
      set
      {
        base.SetProperty(ref this._searchTerm, value);
      }
    }
    public ICommand SearchCommand
    {
      get
      {
        if (this._searchCommand == null)
        {
          this._searchCommand = new DelegateCommand(this.OnSearchCommand);
        }
        return (this._searchCommand);
      }
    }
    void OnSearchCommand()
    {
      this._navigationService.Navigate("SearchResults", this.SearchTerm);
    }
    string _searchTerm;
    ICommand _searchCommand;
    INavigationService _navigationService;
  }
}