﻿namespace MvvmStart.ViewModels
{
  using System.Windows.Input;
  using AbstractionsLibrary;
  using Microsoft.Practices.Prism.StoreApps;
  using Microsoft.Practices.Prism.StoreApps.Interfaces;
  using MvvmStart.Models;
  using MvvmStart.Services;

  public class SearchResultViewModel : 
    ViewModel
  {
    public SearchResultViewModel(
      INavigationService navigationService)
    {
      this._navigationService = navigationService;
    }
    public FlickrSearchItem SearchItem 
    {
      get
      {
        return (this._modelSearchItem);
      }
      set
      {
        this._modelSearchItem = value;
        base.OnPropertyChanged("Title");
        base.OnPropertyChanged("ImageUrl");
        base.OnPropertyChanged("Id");
      }
    }
    public string Title
    {
      get
      {
        return (this._modelSearchItem.Title);
      }
    }
    public string ImageUrl
    {
      get
      {
        return (this._modelSearchItem.ImageUrl);
      }
    }
    public long Id
    {
      get
      {
        return (this._modelSearchItem.Id);
      }
    }
    public ICommand InvokeCommand
    {
      get
      {
        if (this._invokeCommand == null)
        {
          this._invokeCommand = new DelegateCommand(this.OnInvokeCommand);
        }
        return (this._invokeCommand);
      }
    }
    void OnInvokeCommand()
    {
      this._navigationService.Navigate("PhotoDetails", this.Id);
    }
    INavigationService _navigationService;
    ICommand _invokeCommand;
    FlickrSearchItem _modelSearchItem;
  }
}
